Bug 51296 - Dynamic engine support using SSLCryptoDevice support
Summary: Dynamic engine support using SSLCryptoDevice support
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: mod_ssl (show other bugs)
Version: 2.2.17
Hardware: PC Linux
: P2 enhancement (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2011-05-31 06:18 UTC by bsaritha
Modified: 2018-11-07 21:08 UTC (History)
1 user (show)



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description bsaritha 2011-05-31 06:18:01 UTC
is it possible to use dynamic engine in httpd-2.2.17?
 In older version, we were specifying the following directives in httpd.conf file to load our engine dynamically

   SSLCryptoDevice dynamic
   SSLCryptoDeviceCtrl SO_PATH:<PATH to the libpkcs11.so eg:/usr/lib/libcavium.so>
   SSLCryptoDeviceCtrl ID:pkcs11
   SSLCryptoDeviceCtrl LOAD 

NOw, with this version, i am getting the following error
   "Invalid command SSLCryptoDeviceCtrl"

So, please provide steps to use dynamic engine in httpd-2.2.17 


Thanks in advance.
Comment 1 Rainer Jung 2011-05-31 09:56:55 UTC
The SSLCryptoDeviceCtrl  directive was never part of mod_ssl for Apache 2.x.

A patch was proposed in 2004, see for example:

http://www.mail-archive.com/dev@httpd.apache.org/msg19728.html

Joe had a look at it, but it never made it into 2.x.
I didn't have a look myself, so I can't judge whether it would be a good addition.

Regards,

Rainer
Comment 2 bsaritha 2011-06-01 04:56:24 UTC
Thanks, Its working
Comment 3 Michael Kaufmann 2018-09-19 15:15:53 UTC
It's possible to load dynamic engines with SSLCryptoDevice, e.g. "SSLCryptoDevice pkcs11". OpenSSL can find and load dynamic engines automatically.

Maybe OpenSSL is searching the engine in the wrong directory. Use "openssl version -a" to show the engine directory.

If you want to use a different engine directory, set the environment variable OPENSSL_ENGINES before starting httpd, e.g. OPENSSL_ENGINES=/usr/lib .
Comment 4 William A. Rowe Jr. 2018-11-07 21:08:14 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.